#include <string.h>
#include <stdlib.h>
#include "defs.h"
#include "clave.h"

char zicha[36]={'B', 'Z', 'X', 'P',
				'C', 'N', '7', '6',
				'O', 'I', 'H', 'K',
				'V', 'S', 'D', 'W',
				'M', 'Q', 'E', 'A',
				'0', '2', '3', '1',
				'R', 'T', 'Y', 'U',
				'F', 'G', 'J', 'L',
				'8', '5', '9', '4'
};

char *CLAVE_genera_clave(char level, char fase)
{
	char password[5];
	
	password[0]=zicha[level*4+rand()%4];
	password[1]=zicha[fase+8];
	password[2]=zicha[level+fase];
	password[3]=zicha[2*level+fase/2];
	
	password[4]=0;
	
	return strdup(password);
}

short busca_indice(char c)
{
	LOGICO encontrado=0;
	int resultado=-1;
	int i;
	
	for(i=0;i<36 && !encontrado;i++)
	if(zicha[i]==c)
	{
		resultado=i;
		encontrado=CIERTO;
	}
	return(resultado);
}

short CLAVE_decodifica_clave(char *password)
{
	short level;
	short fase;
	
	short clave1, clave2;
	
	level=busca_indice(password[0])/4;
	fase=busca_indice(password[1])-8;
	
	clave1=busca_indice(password[2]);
	clave2=busca_indice(password[3]);
	
	if(clave1!=level+fase)
		return 0;
	
	if(clave2!=2*level+fase/2)
		return 0;
	
	return 25*level+fase;
	
}
