// Phantomasa GFX module

#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include "defs.h"
#include "gfx.h"

LOGICO scanlines = CIERTO;
BITMAP *aux;
BITMAP *negra;
unsigned char _font[128][8];

/**********************************
 * Inicializar el sistema grfico *
 **********************************/

void GFX_init(void)
{
	set_trans_blender(0,0,0,64);
	negra=create_bitmap(512,1);
	aux=create_bitmap(512,384);
	clear(negra);
}

/**********************************
 * Volcar todo al display         *
 **********************************/

void GFX_blitall(BITMAP *buffer)
{
	int i;
	
	if (!scanlines)
	{
		stretch_blit(buffer,screen,0,0,256,192,0,0,512,384);
	}
	else
	{
		stretch_blit(buffer,aux,0,0,256,192,0,0,512,384);
		for(i=0;i<384;i+=2)
			draw_trans_sprite(aux,negra,0,i+1);
		blit(aux,screen,0,0,0,0,512,384);
	}
}

void GFX_scanlines()
{
	scanlines=CIERTO;
}

void GFX_noscanlines()
{
	scanlines=FALSO;
}

/**********************************
 * Fuente 8x8                     *
 **********************************/

void GFX_load_font(char *file)
{
	FILE *pf;
	int i,j;
	
	pf=fopen(file,"rb");
	for (i=0;i<128;i++)
	for(j=0;j<8;j++)
		_font[i][j]=fgetc(pf);
	fclose(pf);
}

void GFX_gprint(BITMAP *buffer, short x, short y, int c, char *texto)
{
	short l,i,xx,yy;
	char ch;
	unsigned char d;
	
	l=strlen(texto);
	for(i=0;i<l;i++)
	{
		ch = texto[i];
		for (yy=0;yy<8;yy++)
		{
			d=_font[ch][yy];
			for(xx=0;xx<7;xx++)
			{
				if( ( d & (1<<(7-xx)) ) == (1<<(7-xx)) )
				{
					putpixel(buffer,x+xx,y+yy,c);
				}
			}
		}
		x+=8;
	}
}

void GFX_gprintb(BITMAP *buffer, short x, short y, int c, char *texto)
{
	short i, j;
	
	for (i = -1; i < 2; i ++)
		for (j = -1; j < 2; j ++)
			if (i != 0 || j != 0)
				GFX_gprint (buffer, x + i, y + j, 0, texto);
				
	GFX_gprint (buffer, x, y, c, texto);
}

void GFX_centra(BITMAP *buffer, short y, int c, char *texto)
{
	short l;
	short x;
	
	l=strlen(texto);
	x=(short)128-(l<<2);
	GFX_gprint(buffer,x,y,c,texto);
}

