#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <allegro.h>
#include <fmod.h>
#include <fblend.h>

#include "defs.h"
#include "clave.h"
#include "cadena.h"
#include "motor.h"
#include "mapas.h"
#include "juego.h"
#include "temporizadores.h"
#include "gfx.h"
#include "key.h"
#include "loga.h"
#include "mapfile.h"
#include "closebuttonhandler.h"

int dt;

int incA[32]={-1295,-1167,-1041,-919,-798,-683,-573,-473,-378,-291,-217,-151,-97,-53,-23,-5,5,23,53,97,151,217,291,378,473,573,683,798,919,1041,1164,1295};
int incL[32]={-662,-596,-529,-465,-403,-342,-286,-232,-186,-142,-102,-68,-42,-19,-7,-0,0,7,19,42,68,102,142,186,232,286,342,403,465,529,596,622};
int tbls[10];
int tblc[10];
int ctbls;
short n_efec = 0;
short has_efec = 0;

short flip_flop = 0;

int nubes1_x = 0;
int nubes2_x = 0;
BITMAP *sp_nubes1;
BITMAP *sp_nubes2;
BITMAP *sp_gotas [6];
BITMAP *sp_overlay_fila4;
BITMAP *sp_halo_verde;
BITMAP *sp_anti_halo;
BITMAP *sp_fancy_overlay;

int moco_y;
int moco_x;


BITMAP *buffer_auxiliar_moco;
BITMAP *buffer_auxiliar_moco_2;
BITMAP *buffer_auxiliar;
BITMAP *buffer_auxiliar_2;
BITMAP *buffer_auxiliar_3;

int transparente;

#define MAX_MVL 512
#define MAX_GOTAS 10
SIMPLE mvl[MAX_MVL];

short signo(int a)
{
	if(a<0)
		return -1;
	else if (a>0)
		return 1;
	else
		return 0;
}

LOGICO yes_no(BITMAP *pantalla,BITMAP *pcx,BITMAP *aux,BITMAP *vacio,BITMAP *lleno,int valor,int fasegrande,int fasechica, int intentos)
{
	BITMAP *sel,*unsel;
	BITMAP *fondo;
	PALETTE pal;
	LOGICO result=FALSO;
	LOGICO terminado=FALSO;
	
	int chnl;
	int vl;
	char prnt[16];
	vl=valor>>1;
	
	// Tocar GO
	
	if(CFG_soundon)
	{
		chnl=FSOUND_PlaySound(FSOUND_FREE,s_go);
		FSOUND_SetPan(chnl,128);
	}
	
	blit(pcx,aux,0,0,0,0,256,192);
	sprintf(prnt,"RETRY x %i",intentos);
	GFX_gprint(aux,152,168,-1,prnt);
	sprintf(prnt,"LEVEL %i - %i",fasegrande,fasechica);
	GFX_gprint(aux,152,176,-1,prnt);
	if (vl>0)
		blit(lleno,aux,0,0,8,168,vl,16);
	if (vl<128)
		blit(vacio,aux,vl,0,8+vl,168,128-vl,16);
	blit(pantalla,aux,0,0,8,16,240,144);
	
	fondo=load_pcx("resources/GUI_sure.pcx",pal);
	sel=load_pcx("resources/BUT_sel.pcx",pal);
	unsel=load_pcx("resources/BUT_unsel.pcx",pal);
	
	while(!terminado)
	{
		if(key[KEY_LEFT] && !result)
		{
			result=CIERTO;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_ting);
				FSOUND_SetPan(chnl,128);
			}
		}
		if(key[KEY_RIGHT] && result)
		{
			result=FALSO;
			if(CFG_soundon)
			{
				chnl=FSOUND_PlaySound(FSOUND_FREE,s_ting);
				FSOUND_SetPan(chnl,128);
			}
		}
		if(key[KEY_ENTER])
			terminado=CIERTO;
		blit(fondo,aux,0,0,56,72,144,48);
		GFX_gprint(aux,64,80,-1,"SURE MY DARLING?");
		if(result)
		{
			blit(sel,aux,0,0,72,92,32,24);
			blit(unsel,aux,0,0,154,92,32,24);
			GFX_gprint(aux,76,100,-1,"Yes");
			GFX_gprint(aux,162,100,-1,"No");
		}
		else
		{
			blit(unsel,aux,0,0,72,92,32,24);
			blit(sel,aux,0,0,154,92,32,24);
			GFX_gprint(aux,76,100,-1,"Yes");
			GFX_gprint(aux,162,100,-1,"No");
		}
		GFX_blitall(aux);
	}
	
	if(CFG_soundon)
	{
		chnl=FSOUND_PlaySound(FSOUND_FREE,s_back);
		FSOUND_SetPan(chnl,128);
	}
	
	destroy_bitmap(sel);
	destroy_bitmap(unsel);
	destroy_bitmap(fondo);
	
	return result;
}

LOGICO recorta_tiles(char *nombre, BITMAP *tiles[])
{
	int i,x,y;
	BITMAP *pcx;
	LOGICO res;
	PALETTE pal;
	
	pcx=create_bitmap(384,160);
	pcx=load_pcx(nombre,pal);
	
	if(pcx!=NULL)
	{
		res=CIERTO;
		x=0;y=0;
		for(i=0;i<240;i++)
		{
			blit(pcx,tiles[i],x,y,0,0,16,16);
			x+=16;
			if(x==384)
			{
				x=0;
				y+=16;
			}
		}
	}
	else
	{
		exit(255);
	}
	return(res);
}

LOGICO cargar(char *nombre,\
	CABECERA *cabecera, MAPA mapa, OBJ *palancas, OBJ *energias,\
BITMAP *fondos[], BITMAP *tiles[], BITMAP *sprites[])
{
	FILE *pf;
	int i,x,y;
	int dot;
	ENERGIAS e;
	PALANCAS p;
	CADENA basurilla[7];
	
	pf=fopen(nombre,"rb");
	
	if(pf==NULL)
		return(FALSO);
	
	fread(cabecera,sizeof(CABECERA),1,pf);
	fread(mapa,sizeof(PANTALLA),25,pf);
	fread(p,sizeof(OBJETO),25,pf);
	fread(e,sizeof(OBJETO),25,pf);
	
	fread(basurilla,sizeof(CADENA),7,pf);
	
	for(i=0;i<25;i++)
	{
		palancas[i].n=p[i].yp*5+p[i].xp;
		energias[i].n=e[i].yp*5+e[i].xp;
		palancas[i].x=p[i].x;
		palancas[i].y=p[i].y;
		energias[i].x=e[i].x;
		energias[i].y=e[i].y;
		palancas[i].on=CIERTO;
		energias[i].on=CIERTO;
	}
	
	for(i=0;i<5;i++)
	for(y=0;y<144;y++)
	for(x=0;x<240;x++)
	{
		fread(&dot,sizeof(int),1,pf);
		putpixel(fondos[i],x,y,dot);
	}
	
	for(i=0;i<240;i++)
	for(y=0;y<16;y++)
	for(x=0;x<16;x++)
	{
		fread(&dot,sizeof(int),1,pf);
		putpixel(tiles[i],x,y,dot);
		fread(&dot,sizeof(int),1,pf);
		putpixel(sprites[i],x,y,dot);
	}
	
	fclose(pf);
	
	return(CIERTO);
}

LOGICO carga_fase(char *nombre,\
	CABECERA *cabecera, MAPA mapa, OBJ *palancas, OBJ *energias,\
BITMAP *fondos[], BITMAP *tiles[], BITMAP *sprites[])
{
	int l;
	LOGICO exito=CIERTO;
	unsigned char flags;
	int n_efec_mapa;
	CADENA nombrePCXs[7];
	CADENA cad;
	PALANCAS p;
	ENERGIAS e;
	
	
	l=strlen(nombre);
	
	
	cad=concatenar_cadenas2("maps/",nombre);
	exito = cargarMapa(cad.contenido, &flags, nombrePCXs, cabecera, mapa, p, e, fondos, tiles, sprites, &n_efec_mapa);
	if(exito && esJugable(flags))
	{
		if(tieneEfecto(flags))
		{
			n_efec = n_efec_mapa;
			has_efec = CIERTO;
		}
		else
		{
			has_efec = FALSO;
		}
	}
	
	if(exito)
	{
		for(l=0;l<25;l++)
		{
			palancas[l].n=p[l].yp*5+p[l].xp;
			energias[l].n=e[l].yp*5+e[l].xp;
			palancas[l].x=p[l].x;
			palancas[l].y=p[l].y;
			energias[l].x=e[l].x;
			energias[l].y=e[l].y;
			palancas[l].on=CIERTO;
			energias[l].on=CIERTO;
		}
	}
	
	return exito;
}

void traza_sombras (JUGADOR phantomas,ENEMIGO *enemigos,ENEMIGO *plataformas,MAPA mapa,OBJ *palancas,OBJ *energias,unsigned char n,\
			  BITMAP *tiles[],BITMAP *sprites[],BITMAP *fondos[],BITMAP *pantalla,CABECERA cabecera)
{
	// Pseudorender simple y escalado traslucido ! ! ! q mieo.
	int i, j;
	
	clear_to_color (buffer_auxiliar, transparente);
	
	// Tiles1:
	for(i=0;i<9;i++)
		for(j=0;j<15;j++)
		{
			if(mapa[n].tiles[i][j].tile1 != -1)
				masked_blit(tiles[mapa[n].tiles[i][j].tile1],buffer_auxiliar,0,0,j<<4,i<<4,16,16);
		}

	// Sprites:
	
	for(i=0;i<25;i++)
	{
		if(palancas[i].n == n)
		{
			if(palancas[i].on)
				masked_blit(sprites[192],buffer_auxiliar,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
			else
				masked_blit(sprites[216],buffer_auxiliar,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
		}
		if(energias[i].n == n)
		{
			if(energias[i].on)
				masked_blit(sprites[193],buffer_auxiliar,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
			else
				masked_blit(sprites[217],buffer_auxiliar,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
		}
	}
	
	for(i=0;i<NENEM;i++)
	{
		if(enemigos[i].id != -1)
		{
			if(enemigos[i].mx >= 0)
				draw_sprite(buffer_auxiliar,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
			else
				draw_sprite_h_flip(buffer_auxiliar,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
		}
	}

	for(i=0;i<NPLAT;i++)
	{
		if(plataformas[i].id != -1)
		{
			draw_sprite(buffer_auxiliar,sprites[plataformas[i].id+plataformas[i].frame],plataformas[i].x,plataformas[i].y);
		}
	}

	if (phantomas.cayendo)
	{
		draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+96+phantomas.frame],phantomas.x>>8,phantomas.y>>8);
	}
	else
	{
		if (phantomas.saltando)
		{
			draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+72],phantomas.x>>8,phantomas.y>>8);
		}
		else
		{
			if(phantomas.frame==0 || phantomas.frame == 48)
			{
				draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda],phantomas.x>>8,phantomas.y>>8);
			}
			else if(phantomas.frame==24)
			{
				draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+24],phantomas.x>>8,phantomas.y>>8);
			}
			else
			{
				draw_sprite(buffer_auxiliar,sprites[phantomas.mira_izda+48],phantomas.x>>8,phantomas.y>>8);
			}
		}
	}

	for(i=0;i<9;i++)
		for(j=0;j<15;j++)
		{
			if(mapa[n].tiles[i][j].tile2 != -1)
				masked_blit(tiles[mapa[n].tiles[i][j].tile2],buffer_auxiliar,0,0,j<<4,i<<4,16,16);
				
		}

	// Ampliar:
	stretch_blit (buffer_auxiliar, buffer_auxiliar_2, (phantomas.x>>8)/7,(phantomas.y>>8)/4,208,112,  0,0,240,144);

	// Volcar:
	clear_to_color (buffer_auxiliar, transparente);
	draw_lit_sprite (buffer_auxiliar, buffer_auxiliar_2, 0, 0, 255);

	// Traslucido:	
	if (dt != 5)
		fblend_trans (buffer_auxiliar, pantalla, 0, 0, 128);
	else
		fblend_trans (buffer_auxiliar, pantalla, 0, 0, 64);
}

int render(JUGADOR phantomas,ENEMIGO *enemigos,ENEMIGO *plataformas,MAPA mapa,OBJ *palancas,OBJ *energias,unsigned char n,\
BITMAP *tiles[],BITMAP *sprites[],BITMAP *fondos[],BITMAP *pantalla,CABECERA cabecera)
{
	int i,j,k;
	short xp,yp,xmr;
	short xx, yy;

	yp=n/5;xp=n%5;

	// Anteprimer volcado: scrolles.
	if (yp == 1)
	{
		rectfill (pantalla, 0, 0, 239, 51, makecol (116, 116, 212));
		rectfill (pantalla, 0, 52, 239, 100, makecol (255, 255, 255));
		
		xx = nubes1_x >> 8;
		
		masked_blit (sp_nubes2, pantalla, xx, 0, 0, 16, 240 - xx, 22);
		masked_blit (sp_nubes2, pantalla, 0, 0, 240 - xx, 16, xx, 22);
		
		xx = nubes2_x >> 8;
		
		masked_blit (sp_nubes1, pantalla, xx, 0, 0, 30, 240 - xx, 22);
		masked_blit (sp_nubes1, pantalla, 0, 0, 240 - xx, 30, xx, 22);
		
		nubes1_x += 64;
		if (nubes1_x >= 61440)
			nubes1_x = 0;
			
		nubes2_x += 32;
		if (nubes2_x >= 61440)
			nubes2_x = 0;
	}
	
	// Primer volcado: El fondo
	
	if(mapa[n].idfondo != -1)
		masked_blit(fondos[mapa[n].idfondo],pantalla,0,0,0,0,240,144);
	else
		rectfill(pantalla,0,0,239,143,0);

	// Primerpuntocinco volcado: Sombras
	
	if (yp == 4)
		traza_sombras (phantomas, enemigos, plataformas, mapa, palancas, energias, n, tiles, sprites, fondos, pantalla, cabecera);
	
	// Segundo volcado: Capa de Tiles 1
	
	if (dt==2 || dt==4)
	{
		for(i=0;i<9;i++)
		for(j=0;j<15;j++)
		{
			if(mapa[n].tiles[i][j].tile1 != -1)
			if(mapa[n].tiles[i][j].tile1<216)
				masked_blit(tiles[mapa[n].tiles[i][j].tile1],pantalla,0,0,j<<4,i<<4,16,16);
			else
			{
				draw_trans_sprite(pantalla,tiles[mapa[n].tiles[i][j].tile1],j<<4,i<<4);
				masked_blit(tiles[mapa[n].tiles[i][j].tile1+6],pantalla,0,0,j<<4,i<<4,16,16);
			}
		}
	}
	else
	{
		for(i=0;i<9;i++)
		for(j=0;j<15;j++)
		{
			if(mapa[n].tiles[i][j].tile1 != -1)
				masked_blit(tiles[mapa[n].tiles[i][j].tile1],pantalla,0,0,j<<4,i<<4,16,16);
		}
	}

	if (yp == 3)
	{
		for (i = 0; i < MAX_GOTAS; i ++)
		{
			if ( mvl [i].ctbls > 0 )
				mvl [i].ctbls --;
			else 
			{
				mvl [i].y += 4;
				fblend_add (sp_gotas [rand () % 3], pantalla, mvl [i].x - 1, mvl [i].y - 1, 128);
				
				// Comprobamos colisin
				
				if ( (mvl [i].y & 15) == 0)
					if ( (mapa [n].tiles [mvl [i].y >> 4][mvl [i].x >> 4].status & 1) == 1 || mvl [i].y >= 144 )
					{
						// Buscamos 8 huecos libres en los salpicones.
						
						for (j = 0; j < 8; j ++)
							for (k = MAX_GOTAS; k < MAX_MVL; k ++)
								if ( mvl [k].ctbls == 0 )
								{
									mvl [k].ctbls = 1;
									mvl [k].frame = 0;
									mvl [k].x = mvl [i].x << 8;
									mvl [k].y = (mvl [i].y - 1) << 8;
									
									mvl [k].my =- (256 + (rand () & 255));
									mvl [k].mx = (rand () & 511) - 256;
									
									k = MAX_MVL;
								}
						
						// Matar, renacer
						
						mvl [i].x = rand() % 240;
						mvl [i].y = (rand() % 9);					
						
						while ( (mapa [n].tiles [mvl [i].y][mvl [i].x >> 4].status & 1) != 1 && mvl [i].y > 0 )
							mvl [i].y --;
							
						if (mvl [i].y != 0)
							mvl [i].y ++;
							
						mvl [i].y = mvl [i].y << 4;
						
						mvl [i].ctbls = rand () & 31;						
						
					}
				
				// putpixel (pantalla, mvl [i].x, mvl [i].y, makecol (255,255,255));
				
			}	
		}
	}		
	if (yp == 0 || yp == 3)
	{
		for (i = MAX_GOTAS; i < MAX_MVL; i ++)
		{
			if (mvl [i].ctbls)
			{
				mvl [i].my += 32;		// Gravedad
				
				mvl [i].x += mvl [i].mx;
				mvl [i].y += mvl [i].my;
				mvl [i].frame ++;
				
				// Colisin o salida:
				
				if ( (mvl [i].x >> 8) < 0 
					|| (mvl [i].x >> 8) > 239
					|| (mvl [i].y >> 8) < 0
					|| (mvl [i].y >> 8) > 143 
					|| mvl [i].frame == 64)
					mvl [i].ctbls = 0;
					
				// putpixel (pantalla, mvl [i].x >> 8, mvl [i].y >> 8, makecol (255, 255, 255));
				fblend_add (sp_gotas [3 + (rand () % 3)], pantalla, 1 + (mvl [i].x >> 8), 1 + (mvl [i].y >> 8), 128 - (mvl [i].frame << 2));
			}
		}		
	}

	
	// Volcado 2 y medio: la puerta!
	
	if(xp==cabecera.pfi_x && yp==cabecera.pfi_y)
		if(phantomas.n_palancas==25)
		{
			masked_blit(sprites[50],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y<<4,16,16);
			masked_blit(sprites[74],pantalla,0,0,cabecera.fin_x<<4,(cabecera.fin_y+1)<<4,16,16);
		}
		else
		{
			masked_blit(sprites[2],pantalla,0,0,cabecera.fin_x<<4,cabecera.fin_y<<4,16,16);
			masked_blit(sprites[26],pantalla,0,0,cabecera.fin_x<<4,(cabecera.fin_y+1)<<4,16,16);
		}
	
	// Tercer volcado: Palancas y Energas
	
	for(i=0;i<25;i++)
	{
		if(palancas[i].n == n)
		{
			if(palancas[i].on)
				masked_blit(sprites[192],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
			else
				masked_blit(sprites[216],pantalla,0,0,palancas[i].x<<4,palancas[i].y<<4,16,16);
		}
		if(energias[i].n == n)
		{
			if(energias[i].on)
				masked_blit(sprites[193],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
			else
				masked_blit(sprites[217],pantalla,0,0,energias[i].x<<4,energias[i].y<<4,16,16);
		}
	}
	
	// Cuarto volcado: Sprites!!
	
	// 1 enemigos y plataformas:
	
	for(i=0;i<NENEM-1;i++)
	{
		if(enemigos[i].id != -1)
		{
			if(enemigos[i].mx >= 0)
				draw_sprite(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
			else
				draw_sprite_h_flip(pantalla,sprites[enemigos[i].id+enemigos[i].frame],enemigos[i].x,enemigos[i].y);
		}
	}
	
	for(i=0;i<NPLAT;i++)
	{
		if(plataformas[i].id != -1)
		{
			draw_sprite(pantalla,sprites[plataformas[i].id+plataformas[i].frame],plataformas[i].x,plataformas[i].y);
		}
	}
	
	// Detalles:
	if (dt==1 || dt==3)		// Iluminacin tras phantomas
	{
		i=rand()%4;
		draw_trans_sprite(pantalla,sprites[98+i],(phantomas.x>>8)-8,(phantomas.y>>8)-8);
		draw_trans_sprite(pantalla,sprites[122+i],(phantomas.x>>8)-8,(phantomas.y>>8)+8);
		draw_trans_sprite(pantalla,sprites[146+i],(phantomas.x>>8)+8,(phantomas.y>>8)-8);
		draw_trans_sprite(pantalla,sprites[170+i],(phantomas.x>>8)+8,(phantomas.y>>8)+8);
	}
	if (dt==4)					// Fuegos fatuos
	{
		for(i=0;i<9;i++)
		{
			mvl[i].x=mvl[i+1].x;
			mvl[i+10].x=mvl[i+11].x;
			mvl[i].y=mvl[i+1].y;
			mvl[i+10].y=mvl[i+11].y;
			mvl[i].ctbls=mvl[i+1].ctbls;
			mvl[i+10].ctbls=mvl[i+11].ctbls;
		}
		mvl[i].x=(phantomas.x>>8)-12;
		mvl[i+10].x=(phantomas.x>>8)+12;
		mvl[i].y=(phantomas.y>>8)-8;
		mvl[i+10].y=(phantomas.y>>8)-8;
		mvl[i].ctbls=ctbls;
		mvl[i+10].ctbls=ctbls;
		
		for(i=0;i<5;i++)
		{
			draw_trans_sprite(pantalla,sprites[98+mvl[0].frame],mvl[i].x+tbls[mvl[i].ctbls],mvl[i<<1].y+tblc[mvl[i].ctbls]);
			draw_trans_sprite(pantalla,sprites[98+mvl[0].frame],mvl[(i<<1)+10].x+tbls[mvl[i].ctbls],mvl[(i<<1)+10].y+tblc[mvl[i].ctbls]);
		}
		
		mvl[0].frame+=24;if(mvl[0].frame>=96) mvl[0].frame=0;
		ctbls++;if(ctbls==10) ctbls=0;
	}
	
	// 2 phantomas:
	
	if (phantomas.cayendo)
	{
		draw_sprite(pantalla,sprites[phantomas.mira_izda+96+phantomas.frame],phantomas.x>>8,phantomas.y>>8);
	}
	else
	{
		if (phantomas.saltando)
		{
			draw_sprite(pantalla,sprites[phantomas.mira_izda+72],phantomas.x>>8,phantomas.y>>8);
		}
		else
		{
			if(phantomas.frame==0 || phantomas.frame == 48)
			{
				draw_sprite(pantalla,sprites[phantomas.mira_izda],phantomas.x>>8,phantomas.y>>8);
			}
			else if(phantomas.frame==24)
			{
				draw_sprite(pantalla,sprites[phantomas.mira_izda+24],phantomas.x>>8,phantomas.y>>8);
			}
			else
			{
				draw_sprite(pantalla,sprites[phantomas.mira_izda+48],phantomas.x>>8,phantomas.y>>8);
			}
		}
	}
	
	// Efecto de las gotas:
		
	
	// Quinto volcado: Capa de Tiles 2
	
	if(dt>1)
		xmr=216;
	else
		xmr=232;
	
	if (dt==1 || dt==2 || dt==4)
	{
		for(i=0;i<9;i++)
			for(j=0;j<15;j++)
			{
				if(mapa[n].tiles[i][j].tile2 != -1)
				if(mapa[n].tiles[i][j].tile2<xmr)
					masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
				else
					fblend_add (tiles[mapa[n].tiles[i][j].tile2], pantalla, j<<4, i<<4, 64);
					//draw_trans_sprite(pantalla,tiles[mapa[n].tiles[i][j].tile2],j<<4,i<<4);
			}
	}
	else
	{
		for(i=0;i<9;i++)
			for(j=0;j<15;j++)
			{
				if(mapa[n].tiles[i][j].tile2 != -1)
					masked_blit(tiles[mapa[n].tiles[i][j].tile2],pantalla,0,0,j<<4,i<<4,16,16);
			}
	}

	
	// Halos y overlays:
		
	if (dt==1 || dt==2 || dt==4)
	{
		for(i=0;i<9;i++)
			for(j=0;j<15;j++)
			{
				if(mapa[n].tiles[i][j].tile1 == 164 || mapa[n].tiles[i][j].tile2 == 164)
					fblend_add (sp_halo_verde, pantalla, (j<<4) - 16, (i<<4) - 16, 64);
					
			}
	}
	
	if (yp == 3) {
		fblend_add (sp_overlay_fila4, pantalla, 0, 0, 128);
	} else if (yp == 4) {
		fblend_trans (buffer_auxiliar_moco, pantalla, 0, 0, 128);
		
        if (xp == 4) {
			/*
            blit (sp_anti_halo, buffer_auxiliar_3, 240-(phantomas.x>>8), 144-(phantomas.y>>8), 0, 0, 240, 144);
            fblend_sub (sp_fancy_overlay, buffer_auxiliar_3, 0, 0, 255);
            fblend_sub (buffer_auxiliar_3, pantalla, 0, 0, 128);
            fblend_add (sp_fancy_overlay, pantalla, 0,0, 64);
            */

			fblend_add (sp_fancy_overlay, pantalla, 0, 0, 64);
        } else {
            fblend_sub (sp_anti_halo, pantalla, (phantomas.x>>8)-240, (phantomas.y>>8)-144, 128);    
        }
	}
	
	return(0);
}

void blitter(BITMAP *pantalla,BITMAP *pcx,BITMAP *aux,BITMAP *vacio,BITMAP *lleno,int valor,int fasegrande,int fasechica, int intentos)
{
	// Cambiar:
	int vl;
	char prnt[16];
	vl=valor>>1;
	
	blit(pcx,aux,0,0,0,0,256,192);
	sprintf(prnt,"RETRY x %i",intentos);
	GFX_gprintb(aux,152,168,-1,prnt);
	sprintf(prnt,"LEVEL %i - %i",fasegrande,fasechica);
	GFX_gprintb(aux,152,176,-1,prnt);
	if (vl>0)
		blit(lleno,aux,0,0,8,168,vl,16);
	if (vl<128)
		blit(vacio,aux,vl,0,8+vl,168,128-vl,16);
	blit(pantalla,aux,0,0,8,16,240,144);
	GFX_blitall(aux);
}

int juego(char *nombre, int indicador)
{
	int detalles=0;
	int mitad;
	FMUSIC_MODULE *musica;
	PALETTE pal;
	int chnl;
	BITMAP *sprites[240];
	BITMAP *tiles[240];
	CABECERA cabecera;
	MAPA mapa;
	short fila;
	OBJ palancas[25];
	OBJ energias[25];
	BITMAP *fondos[5];
	JUGADOR phantomas;
	ENEMIGO enemigos[NENEM];
	ENEMIGO plat[NPLAT];
	int xp, yp, xpa, ypa, pantalla, pfinal;
	LOGICO terminado;
	LOGICO finalizar=FALSO;
	int exito=ESCAPE;
	BITMAP *p_juego;
	BITMAP *aux;
	BITMAP *pcx;
	BITMAP *vacio,*lleno;
	BITMAP *scr;
	BITMAP *aux_gotas;
	BITMAP *sp_moco [4];
	BITMAP *aux_moco;
	short gengotas = 0;
	
	LOGICO debug=FALSO;
	int fasegrande,fasechica;
	int xx,yy;					// Coordenadas ajustadas a tiles
	int i,j,k,x,y,ax;				// Coordenadas ajustadas a pxels
	int chnl_en=-1,chnl_caer=-1;
	int intentos;
	char fasename[32];
	FSOUND_SAMPLE *s_energia,*s_salto,*s_palanca,*s_caer,*s_enemigo,*s_suelo;
	LOGICO sonido_cayendo=FALSO;
	char n_musica[256];
	short flip_flop2;
	
	loga ("Empezamos motor :) ");
	
	transparente = makecol (255,0,255);
	
	rtrim(nombre);				// Necesario viniendo del men.
	minusculas(nombre);
	
	fasegrande=GAME_level;
	fasechica=GAME_sublevel;
	intentos=5;
	
	// Cambiar luego
	detalles=2;
	
	sprintf(n_musica,"resources/%s",nombre);
	i=strlen(n_musica);
	n_musica[i-1]=0;
	n_musica[i-2]='m';
	n_musica[i-3]='x';
	
	musica=FMUSIC_LoadSong(n_musica);
	FMUSIC_SetMasterVolume(musica,CFG_soundvol<<1);
	
	loga ("Reservando memoria para buffers grficos");
	p_juego=create_bitmap(240,144);
	aux=create_bitmap(256,192);
	scr=create_bitmap(256,192);
	buffer_auxiliar = create_bitmap (240,144);
	buffer_auxiliar_2 = create_bitmap (240,144);
	buffer_auxiliar_3 = create_bitmap (240,144);
	buffer_auxiliar_moco = create_bitmap (240,144);
	buffer_auxiliar_moco_2 = create_bitmap (240,144);
	
	loga ("Cargando recursos grficos...");
	lleno=load_pcx("resources/ENE_Lle.pcx",pal);
	vacio=load_pcx("resources/ENE_Vac.pcx",pal);

	sp_nubes1 = load_pcx ("resources/clouds_1.pcx", pal);
	sp_nubes2 = load_pcx ("resources/clouds_2.pcx", pal);
	sp_halo_verde = load_pcx ("resources/halo_verde.pcx", pal);
	sp_anti_halo = load_pcx ("resources/anti_halo.pcx", pal);
	sp_overlay_fila4 = load_pcx ("resources/OVERLAY-fila4.pcx", pal);
	sp_fancy_overlay = load_pcx ("resources/fancy-overlay.pcx", pal);
	aux_gotas = load_pcx ("resources/gotas.pcx", pal);
	aux_moco = load_pcx ("resources/moco.pcx", pal);
	
	for (i = 0; i < 6; i ++) {
		sp_gotas [i] = create_bitmap (4, 4);
		blit (aux_gotas, sp_gotas [i], i << 2, 0, 0, 0, 4, 4);
	}
	destroy_bitmap (aux_gotas);
	
	for (i = 0; i < 4; i ++) {
		sp_moco [i] = create_bitmap (8, 8);
		blit (aux_moco, sp_moco [i], i << 3, 0, 0, 0, 8, 8);
	}
	destroy_bitmap (aux_moco);
	
	nubes1_x = 0;
	nubes2_x = 0;
	
	dt=detalles;
	
	loga ("Creando bitmaps...");
	
	// Creacin de todos los bitmaps:
	
	for(i=0;i<240;i++)
	{
		sprites[i]=create_bitmap(16,16);
		tiles[i]=create_bitmap(16,16);
	}
	
	for(i=0;i<5;i++)
		fondos[i]=create_bitmap(240,144);
	
	clear(p_juego);
	
	loga ("Cargando fase:");
	loga (nombre);
	
	if(!(exito=carga_fase(nombre, &cabecera, mapa, palancas, energias, fondos, tiles, sprites)))
		return(FALLO);
	
	loga ("Fase cargada OK");
	
	xp=0;	// Todas las fases empiezan en 0,0 y terminan en 4,4
	yp=0;
	
	pfinal=5*4+4;
	
	for(i=0;i<25;i++)
	{
		palancas[i].on=CIERTO;
		energias[i].on=CIERTO;
	}
	
	pantalla=5*yp+xp;
	
	pcx=load_pcx("resources/MARCO.PCX",pal);
	phantomas.energia=255;
	
	if(CFG_soundon)
	{
		loga ("Cargando sonidos");
		FMUSIC_PlaySong(musica);
		s_energia=FSOUND_Sample_Load(FSOUND_FREE,"resources/energia.wav",FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_salto=  FSOUND_Sample_Load(FSOUND_FREE,"resources/salto.wav",  FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_palanca=FSOUND_Sample_Load(FSOUND_FREE,"resources/palanca.wav",FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_caer=   FSOUND_Sample_Load(FSOUND_FREE,"resources/caer.wav",   FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_enemigo=FSOUND_Sample_Load(FSOUND_FREE,"resources/enemigo.wav",FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_suelo=  FSOUND_Sample_Load(FSOUND_FREE,"resources/suelo.wav",  FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		FSOUND_SetSFXMasterVolume(CFG_sfxvol<<1);
	}
	
	if(dt==4)
	{
		ctbls=0;
		for(i=0;i<10;i++)
		{
			tbls[i]=(int)( (float) 2 * sin(2 * 3.1415916 * (float)i / 10) );
			tblc[i]=(int)( (float) 2 * cos(2 * 3.1415916 * (float)i / 10) );
		}
	}
	
	finalizar = FALSE;
	
	if (GAME_level > 1) {
	   GAME_sublevel = 25;
	   GAME_level = 1;
    }
	
	while(!finalizar)	// Ok, bucle principal
	{
    	
		// Rellena las estructuras de los enemigos:
		
		// pantalla=5*yp+xp;
		pantalla=GAME_sublevel-1;
		
		if (GAME_sublevel > 14 && GAME_sublevel < 20)
		{
			// Voy a crear las gotas.
			
			for (i = 0; i < MAX_GOTAS; i ++)
			{				
				mvl [i].x = rand() % 240;
				mvl [i].y = (rand() % 9);					
				
				while ( (mapa [pantalla].tiles [mvl [i].y][mvl [i].x >> 4].status & 1) != 1 && mvl [i].y > 0 )
					mvl [i].y --;
					
				if (mvl [i].y != 0)
					mvl [i].y ++;
					
				mvl [i].y = mvl [i].y << 4;
				
				mvl [i].ctbls = rand () & 31;
			}			
			
			// Desactivamos todos los salpicones.
			
			for (i = MAX_GOTAS; i < MAX_MVL; i ++)
				mvl [i].ctbls = 0;
		}
		
		clear(scr);
		sprintf(fasename,"LEVEL %i - %i",GAME_level,GAME_sublevel);
		GFX_centra(scr,88,-1,fasename);
		GFX_centra(scr,100,-1,CLAVE_genera_clave(GAME_level,GAME_sublevel));
		GFX_blitall(scr);
		
		KEY_wait_action_key();
		
		loga ("Creando enemigos y plataformas");
		
		for(i=0;i<NENEM-1;i++)
		{
			enemigos[i].x=mapa[pantalla].enemigos[i].ini_x*16;
			enemigos[i].y=mapa[pantalla].enemigos[i].ini_y*16;
			
			enemigos[i].mx=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_x - mapa[pantalla].enemigos[i].ini_x);
			enemigos[i].my=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_y - mapa[pantalla].enemigos[i].ini_y);
			
			enemigos[i].id=mapa[pantalla].enemigos[i].id;
			enemigos[i].frame=0;
			enemigos[i].ini_x=mapa[pantalla].enemigos[i].ini_x*16;
			enemigos[i].ini_y=mapa[pantalla].enemigos[i].ini_y*16;
			enemigos[i].fin_x=mapa[pantalla].enemigos[i].fin_x*16;
			enemigos[i].fin_y=mapa[pantalla].enemigos[i].fin_y*16;
		}
		
		for(i=0;i<NPLAT;i++)
		{
			plat[i].x=mapa[pantalla].plataformas[i].ini_x*16;
			plat[i].y=mapa[pantalla].plataformas[i].ini_y*16;
			
			plat[i].mx=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_x - mapa[pantalla].plataformas[i].ini_x);
			plat[i].my=mapa[pantalla].plataformas[i].vel * signo(mapa[pantalla].plataformas[i].fin_y - mapa[pantalla].plataformas[i].ini_y);
			
			plat[i].id=mapa[pantalla].plataformas[i].id;
			plat[i].frame=0;
			plat[i].ini_x=mapa[pantalla].plataformas[i].ini_x*16;
			plat[i].ini_y=mapa[pantalla].plataformas[i].ini_y*16;
			plat[i].fin_x=mapa[pantalla].plataformas[i].fin_x*16;
			plat[i].fin_y=mapa[pantalla].plataformas[i].fin_y*16;
		}
		
		loga ("Creando sistemas de partculas");
		
		if(dt==4)		// Fuegos fatuos:
		{
			for (i=0;i<10;i++)
			{
				mvl[i].x=(phantomas.x>>8)-16;
				mvl[i+10].x=(phantomas.x>>8)+16;
				mvl[i].y=(phantomas.y>>8)-8;
				mvl[i+10].y=(phantomas.y>>8)-8;
				mvl[i].frame=0;
				mvl[i+10].frame=0;
				mvl[i].ctbls=0;
				mvl[i+10].ctbls=0;
				ctbls=0;
			}
		}
		
		phantomas.x=256*16*mapa[pantalla].enemigos[24].ini_x;	// Hay que refinar esto... Cambiar / Parchear editor?
		phantomas.y=256*16*mapa[pantalla].enemigos[24].ini_y;	// Naaaah! :D
		phantomas.frame=0;
		phantomas.cayendo=FALSO;
		phantomas.saltando=FALSO;
		phantomas.sobre_plataforma=FALSO;
		phantomas.contador_salto=0;
		phantomas.mira_izda=(mapa[pantalla].enemigos[24].ini_x>mapa[pantalla].enemigos[24].fin_x);
		phantomas.salto_largo=FALSO;
		phantomas.n_palancas=0;
		phantomas.contador_caida=0;
		
		terminado=FALSO;
		
		loga ("Comenzando el juego 2");
		fila = pantalla / 5;
		
		moco_x = 0;
		moco_y = 0;
		clear_to_color (buffer_auxiliar_moco_2, transparente);
		
		while(!terminado)
		{
			// Controla si salimos pulsando ESC:
				
			flip_flop = !flip_flop;
						
			if(key[KEY_ESC])
			{
				terminado=CIERTO;
				finalizar=CIERTO;
			}
			
			if(key[KEY_D])
			{
				debug=CIERTO;
			}
			
			// Rellenar moco:
				
			if (fila == 4 && flip_flop) {
				blit (buffer_auxiliar_moco_2, buffer_auxiliar_moco, 0, 0, 0, 0, 240, 144);
				for (moco_x = 0; moco_x <= 240; moco_x += 4)
					draw_sprite (buffer_auxiliar_moco, sp_moco [(rand() & 3)], moco_x-4, moco_y-4);
			
				flip_flop2 = (flip_flop2 + 1) & 7;	
				if (flip_flop2 == 0) {
					moco_y += 1;
					blit (buffer_auxiliar_moco, buffer_auxiliar_moco_2, 0, 0, 0, 0, 240, 144);
				}
			}
			
			// Movimiento de Phantomas [lo gordo]:
			
			// Recalcular:
			xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
			
			xpa=xp;
			ypa=yp;
			
			// El tiesto este suele ser muy sencillo, pero aqu es ms coazo
			// principalmente porque el salto no es lineal, sino que es parablico
			// y est precalculado (ya se sabe, el Phantomas III de MSDOS tena
			// que ir bien en mi 486DX2, as que toda optimizacin que ahora parece
			// estpida estaba muy bien vista).
			
			// Hay que ver lo que me gusta escribir gilichorreces en el cdigo...
			// Total, pa luego leerlo a los aos y pensar... Qu polla era!
			
			if(phantomas.saltando)
			{
				// Incrementa el contador de salto y
				// cambia las coordenadas de phantomas. [OK]
				// Comprueba si nos posamos sobre algn tile para para el salto. [OK]
				// Comprueba que phantomas salga por la izquierda o por la derecha [OK]
				// Comprueba que phantomas salga por arriba o por abajo [OK]
				// y hace las gestiones necesarias. [OK]
				
				// Movimiento vertical:
				
				if(phantomas.salto_largo)	// SALTO LARGO
				{
					if(phantomas.contador_salto<16)		// Subiendo, comprobar si podemos
					{
						if((yy<<4) == y && yy!=0)		// A borde de recuadro, mirar
						{
							if((xx<<4) == x || xx == 14)
							{
								if((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1)
									phantomas.y+=incL[phantomas.contador_salto];
							}
							else
							{
								if((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1 && (mapa[pantalla].tiles[yy-1][xx+1].status & 1) != 1)
									phantomas.y+=incL[phantomas.contador_salto];
							}
						}
						else
						{
							phantomas.y+=incL[phantomas.contador_salto];
						}
						// Problema de incrementos variables, solucin al canto:
						// Si hemos entrado en un tile - bloque, directamente ajustamos
						// al tile inferior.
						xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
						
						if(yy>=0)
						{
							
							if((xx<<4) == x || xx == 14)
							{
								if((mapa[pantalla].tiles[yy][xx].status & 1) == 1)
									phantomas.y=((yy+1)<<12);
							}
							else
							{
								if((mapa[pantalla].tiles[yy][xx].status & 1) == 1 || (mapa[pantalla].tiles[yy][xx+1].status & 1) == 1)
									phantomas.y=((yy+1)<<12);
							}
						}
					}
					else  // Bajando
					{
						phantomas.y+=incL[phantomas.contador_salto];
					}
					phantomas.contador_salto++;
					if(phantomas.contador_salto==32)
					{
						phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
						phantomas.x=((phantomas.x>>9)<<9);
						phantomas.contador_salto=0;
						phantomas.saltando=FALSO;
					}
				}
				else	// SALTO ALTO
				{
					if(phantomas.contador_salto<16)		// Subiendo, comprobar si podemos
					{
						if((yy<<4) == y && yy!=0)		// A borde de recuadro, mirar
						{
							if((xx<<4) == x || xx == 14)
							{
								if((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1)
									phantomas.y+=incA[phantomas.contador_salto];
							}
							else
							{
								if((mapa[pantalla].tiles[yy-1][xx].status & 1) != 1 && (mapa[pantalla].tiles[yy-1][xx+1].status & 1) != 1)
									phantomas.y+=incA[phantomas.contador_salto];
							}
						}
						else
						{
							phantomas.y+=incA[phantomas.contador_salto];
						}
						
						// Problema de incrementos variables, solucin al canto:
						// Si hemos entrado en un tile - bloque, directamente ajustamos
						// al tile inferior.
						xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
						
						if(yy>=0)
						{
							if((xx<<4) == x || xx == 14)
							{
								if((mapa[pantalla].tiles[yy][xx].status & 1) == 1)
								{
									phantomas.y=((yy+1)<<12);
								}
							}
							else
							{
								if(((mapa[pantalla].tiles[yy][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy][xx+1].status & 1) == 1))
								{
									phantomas.y=((yy+1)<<12);
								}
							}
						}
					}
					else  // Bajando
					{
						phantomas.y+=incA[phantomas.contador_salto];
					}
					phantomas.contador_salto++;
					if(phantomas.contador_salto==32)
					{
						phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
						phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512						phantomas.contador_salto=0;
						phantomas.saltando=FALSO;
					}
				}
				
				// Recalcular:
				xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
				
				// Plataformas:
				
				for(i=0;i<NPLAT;i++)
				if(plat[i].id != -1)
				{
					// Comprobamos si phantomas est sobre una plataforma mvil,
					// en ese caso paramos la cada y desplazamos a phantomas junto
					// con la plataforma
					
					if(plat[i].mx!=0)		// La plataforma se mueve horizontalmente.
					{
						// Ver si podemos 'capturar' a Phantomas.
						// esto ocurre si phantomas est aqu:
						//	x-15	  x	  x+15
						//	 [--------[XXXXXX|]------]
						// Y separado de 1 a 4 pxels del extremo superior de la
						// plataforma:
						
						if(x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-16 && phantomas.contador_salto >2)
						{
							// 'atrapamos' a phantomas:
							phantomas.saltando=FALSO;
							phantomas.y=((plat[i].y-16)<<8);
							
							xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
							
							// Vemos si podemos arrastrar a phantomas junto con la plataforma:
							ax=((x+plat[i].mx)>>4);	// Tile que ocupara tras el movimiento
							
							if(plat[i].mx<0)	// Hacia la izquierda
							{
								if( (yy<<4) == y)
								{
									if( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy][ax].status & 16) != 16) )
										phantomas.x+=(plat[i].mx<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) && ((mapa[pantalla].tiles[yy][ax].status & 16) != 16) && ((mapa[pantalla].tiles[yy+1][ax].status & 16) != 16 ))
										phantomas.x+=(plat[i].mx<<8);
								}
							}
							else	// Hacia la derecha
							{
								if( (yy<<4) == y)
								{
									if( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy][ax+1].status & 16) != 16))
										phantomas.x+=(plat[i].mx<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) && ((mapa[pantalla].tiles[yy][ax+1].status & 16) != 16) && ((mapa[pantalla].tiles[yy+1][ax].status & 16) != 16 ) )
										phantomas.x+=(plat[i].mx<<8);
								}
							}
						}
					}
					else	// La plataforma se mueve verticalmente.
					{
						// Ver si podemos 'capturar' a Phantomas.
						// esto ocurre si phantomas est aqu:
						//	x-15	  x	  x+15
						//	 [--------[XXXXXX|]------]
						// Y separado de 1 a 4 pxels del extremo superior de la
						// plataforma:
						
						if(x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-18 && y<=plat[i].y-14)
						{
							// 'atrapamos' a phantomas:
							phantomas.saltando=FALSO;
							
							// Vemos si podemos arrastrar a phantomas:
							ax=((y+plat[i].my)>>4);
							
							if (plat[i].my<0)		// hacia arriba
							{
								if( (xx<<4) == x)
								{
									if( (mapa[pantalla].tiles[ax][xx].status & 1)!= 1)
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[ax][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax][xx+1].status & 1)!= 1) )
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
							}
							else	// hacia abajo
							{
								if( (xx<<4) == x)
								{
									if( (mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1)
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax+1][xx+1].status & 1)!= 1) )
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
							}
						}
					}
				}
				
				// Comprobamos si nos posamos:
				
				if(phantomas.contador_salto>=mitad)
				{
					if((yy<<4)==y && yy!=8)
					{
						if( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) )
						{
							phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
							phantomas.saltando=FALSO;
							phantomas.x=((phantomas.x>>9)<<9); // Ajusta a mltiplo de 512
							phantomas.frame=0;
						}
						if((xx<<4) != x && xx != 14)
						if( ((mapa[pantalla].tiles[yy+1][xx+1].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16) )
						{
							phantomas.y=((phantomas.y>>8)<<8); //Ajustar a las coordenadas
							phantomas.saltando=FALSO;
							phantomas.x=((phantomas.x>>9)<<9);	// Ajusta a mltiplo de 512
							phantomas.frame=0;
						}
					}
					else
					{
						// A veces, debido a los incrementos variables, puede que se sobrepase la plataforma.
						// en ese caso, habr que ajustar (esto ocurre, por ejemplo, en JILL y GAIA):
						if( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) )
						{
							phantomas.y=((phantomas.y>>12)<<12);
							phantomas.saltando=FALSO;
							phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512
							phantomas.frame=0;
						}
						if((xx<<4) != x && xx != 14)
						{
							if( ((mapa[pantalla].tiles[yy+1][xx].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx].status & 16) == 16) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 1 == 1)) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16))
							{
								phantomas.y=((phantomas.y>>12)<<12);
								phantomas.saltando=FALSO;
								phantomas.x=((phantomas.x>>9)<<9);		// Ajusta a mltiplo de 512
								phantomas.frame=0;
							}
						}
					}
					
				}
				
				// Comprobamos si salimos de la pantalla por arriba
				if(phantomas.y<0)
				{
					phantomas.y=0;		// No se puede cambiar de pantalla en Phantomasa!
					xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
				}
				
				// Comprobamos si salimos de la pantalla por abajo
				
				if(phantomas.y>32768)
				{
					phantomas.y=32768; 	// Ajustar si no podemos salir por abajo
					xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
				}
				
				// Movimiento horizontal
				
				ax=((x>>1)<<1);
				
				if(phantomas.mira_izda)
				{
					if((xx<<4) == ax && xx != 0)
					{
						if((yy<<4) == y || yy == 8)	// Mirar solo en el recuadro izquierdo
						{
							if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
								phantomas.x-=(256+(phantomas.salto_largo<<8));
						}
						else	// Mirar, adems, en el inferior izquierdo.
						{
							if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx-1].status & 1) != 1)
								phantomas.x-=(256+(phantomas.salto_largo<<8));
						}
					}
					else
						phantomas.x-=(256+(phantomas.salto_largo<<8));
				}
				else
				{
					if((xx<<4) == ax && xx != 14)
					{
						if((yy<<4) == y || yy == 8)	// Mirar solo en el recuadro derecho
						{
							if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
								phantomas.x+=(256+(phantomas.salto_largo<<8));
						}
						else	// Mirar, adems, en el inferior izquierdo.
						{
							if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx+1].status & 1) != 1)
								phantomas.x+=(256+(phantomas.salto_largo<<8));
						}
					}
					else
						phantomas.x+=(256+(phantomas.salto_largo<<8));
				}
				
				// Comprobamos si salimos de la pantalla por la izquierda o por la derecha
				
				if(phantomas.x<0)
				{
					phantomas.x=0;
				}
				
				if(phantomas.x>57344)
				{
					phantomas.x=57344;
				}
			}
			else
			{
				phantomas.cayendo = CIERTO;
				
				// Tratemos de parar al phantomas
				// Detectar obstculos o plataformas debajo, adems de plataformas
				// mviles.
				
				if((yy<<4) == y && yy!=8)		// Solo si est justo en el recuadro
				{
					if((xx<<4) == x || xx == 14)	// Comprueba solo debajo:
					{
						// Vemos qu tile hay debajo y:
						// 1. Paramos la cada
						
						if((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx].status & 16) == 16 )
						{
							phantomas.cayendo=FALSO;
							
							// 2. Si es un tile que desplaza vemos si podemos o no desplazar.
							
							// A la derecha:
							if((mapa[pantalla].tiles[yy+1][xx].status & 4) == 4)
							{
								if((xx<<4) == x && xx != 14)
								{
									if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
										phantomas.x+=256;
								}
								else
								{
									phantomas.x+=256;
								}
							}
							// A la izquierda:
							else if((mapa[pantalla].tiles[yy+1][xx].status & 8) == 8)
							{
								if((xx<<4) == x && xx != 0)
								{
									if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
										phantomas.x-=256;
								}
								else
								{
									phantomas.x-=256;
								}
							}
							
							// Comprobamos si salimos de la pantalla por la izquierda o por la derecha
							
							if(phantomas.x<0)
							{
								phantomas.x=0;
							}
							
							if(phantomas.x>57344)
							{
								phantomas.x=57344;
							}
						}
					}
					else									// Comprueba debajo y debajo a la der.
					{
						// Vemos qu tile hay debajo y debajo a la der. y:
						// 1. Paramos la cada
						
						if((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx].status & 16) == 16  ||  (mapa[pantalla].tiles[yy+1][xx+1].status & 1) == 1  ||  (mapa[pantalla].tiles[yy+1][xx+1].status & 16) == 16 )
						{
							phantomas.cayendo=FALSO;
							
							// 2. Si es un tile que desplaza vemos si podemos o no desplazar.
							
							// A la derecha:
							if((mapa[pantalla].tiles[yy+1][xx].status & 4) == 4 || (mapa[pantalla].tiles[yy+1][xx+1].status & 4) == 4)
							{
								if((xx<<4) == x && xx != 14)
								{
									if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
										phantomas.x+=256;
								}
								else
								{
									phantomas.x+=256;
								}
							}
							// A la izquierda:
							else if((mapa[pantalla].tiles[yy+1][xx].status & 8) == 8 || (mapa[pantalla].tiles[yy+1][xx+1].status & 8) == 8 )
							{
								if((xx<<4) == x && xx != 0)
								{
									if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
										phantomas.x-=256;
								}
								else
								{
									phantomas.x-=256;
								}
							}
							
							// Comprobamos si salimos de la pantalla por la izquierda o por la derecha
							
							if(phantomas.x<0)
							{
								phantomas.x=0;
							}
							
							if(phantomas.x>57344)
							{
								phantomas.x=57344;
							}
						}
					}
				}
				
				// Plataformas mviles.
				
				xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
				
				
				for(i=0;i<NPLAT;i++)
				if(plat[i].id != -1)
				{
					// Comprobamos si phantomas est sobre una plataforma mvil,
					// en ese caso paramos la cada y desplazamos a phantomas junto
					// con la plataforma
					
					if(plat[i].mx!=0)		// La plataforma se mueve horizontalmente.
					{
						// Ver si podemos 'capturar' a Phantomas.
						// esto ocurre si phantomas est aqu:
						//	x-15	  x	  x+15
						//	 [--------[XXXXXX|]------]
						// Y separado de 1 a 4 pxels del extremo superior de la
						// plataforma:
						
						if(x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-16)
						{
							// 'atrapamos' a phantomas:
							phantomas.cayendo=FALSO;
							phantomas.y=((plat[i].y-16)<<8);
							
							xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
							
							// Vemos si podemos arrastrar a phantomas junto con la plataforma:
							ax=((x+plat[i].mx)>>4);	// Tile que ocupara tras el movimiento
							
							if(plat[i].mx<0)	// Hacia la izquierda
							{
								if( (yy<<4) == y)
								{
									if( (mapa[pantalla].tiles[yy][ax].status & 1) != 1 )
										phantomas.x+=(plat[i].mx<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[yy][ax].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) )
										phantomas.x+=(plat[i].mx<<8);
								}
							}
							else	// Hacia la derecha
							{
								if( (yy<<4) == y)
								{
									if( (mapa[pantalla].tiles[yy][ax+1].status & 1) != 1 )
										phantomas.x+=(plat[i].mx<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[yy][ax+1].status & 1) != 1) && ((mapa[pantalla].tiles[yy+1][ax].status & 1) != 1 ) )
										phantomas.x+=(plat[i].mx<<8);
								}
							}
						}
					}
					else	// La plataforma se mueve verticalmente.
					{
						// Ver si podemos 'capturar' a Phantomas.
						// esto ocurre si phantomas est aqu:
						//	x-15	  x	  x+15
						//	 [--------[XXXXXX|]------]
						// Y separado de 1 a 4 pxels del extremo superior de la
						// plataforma:
						
						if(x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-19 && y<=plat[i].y-14)
						{
							// 'atrapamos' a phantomas:
							
							// Vemos si podemos arrastrar a phantomas:
							ax=((y+plat[i].my)>>4);
							
							if (plat[i].my<0)		// hacia arriba
							{
								if( (xx<<4) == x)
								{
									if( (mapa[pantalla].tiles[ax][xx].status & 1)!= 1)
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[ax][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax][xx+1].status & 1)!= 1) )
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
							}
							else	// hacia abajo
							{
								if( (xx<<4) == x)
								{
									if( (mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1)
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
								else
								{
									if( ((mapa[pantalla].tiles[ax+1][xx].status & 1)!= 1) && ((mapa[pantalla].tiles[ax+1][xx+1].status & 1)!= 1))
										phantomas.y=((plat[i].y-16+plat[i].my)<<8);
								}
							}
							phantomas.cayendo=FALSO;
						}
					}
				}
				
				// Caso especial:
				if(yy==8) phantomas.cayendo=FALSO;
				
				if (phantomas.cayendo)
				{
					phantomas.y=(phantomas.y>>10)<<10; // Ajuste:
					phantomas.y+=1024;
					
					xx=(phantomas.x>>12); yy=(phantomas.y>>12); x=(phantomas.x>>8); y=(phantomas.y>>8);
					
					if( yy < 8 )
					if( (xx<<4) == x )
					{
						if( (mapa[pantalla].tiles[yy+1][xx].status & 1) == 1)
							phantomas.y=(yy<<12);
					}
					else
					{
						if( ((mapa[pantalla].tiles[yy+1][xx].status & 1) == 1) || ((mapa[pantalla].tiles[yy+1][xx+1].status & 1) == 1) )
							phantomas.y=(yy<<12);
					}
					
					if(phantomas.contador_caida>4)
					{
						phantomas.frame+=24;
						if(!sonido_cayendo)
						if(CFG_soundon)
						{
							chnl=FSOUND_PlaySound(FSOUND_FREE,s_caer);
							FSOUND_SetPan(chnl,8+(phantomas.x>>8));
							chnl_caer=chnl;
						}
						sonido_cayendo=CIERTO;
						
						if(phantomas.frame==96)
							phantomas.frame=0;
					}
					else
					{
						phantomas.frame=0;
						phantomas.contador_caida++;
					}
					
					// Comprobamos si salimos de la pantalla por abajo
					
					if(phantomas.y>32768)
					{
						phantomas.y=32768; 	// Ajustar si no podemos salir por abajo
					}
				}
				else
				{
					phantomas.contador_caida=0;
					if(CFG_soundon)
					{
						
						if(CFG_soundon)
						{
							if(chnl_caer!=-1)
							{
								FSOUND_StopSound(chnl_caer);
								chnl_caer=-1;
							}
							if(sonido_cayendo)
							{
								if (yp == 0 || yp == 3)
									gengotas = 1;
								
								chnl=FSOUND_PlaySound(FSOUND_FREE,s_suelo);
								FSOUND_SetPan(chnl,8+(phantomas.x>>8));
							}
							
						}
						
					}
					sonido_cayendo=FALSO;
					
					// Movimiento lateral:
					// Mira si se pulsan las teclas de movimiento lateral y mueve
					// a phantomas en el sentido correcto.
					// Comprueba tambin si phantomas sale por la izq o por la der
					// y hace las gestiones necesarias.
					// Activa el salto si se pulsan las teclas
					
					i = phantomas.x;
					
					if(key[KEY_LEFT] || key[KEY_O])				// Izquierda
					{
						if (phantomas.mira_izda)
						{
							if(phantomas.x != ((phantomas.x>>9)<<9))
								phantomas.x=((phantomas.x>>9)<<9) + 512;
							phantomas.frame+=24;
							
							if(phantomas.frame==96)
								phantomas.frame=0;
							
							phantomas.mira_izda=CIERTO;
							
							if((xx<<4) == x && xx != 0)
							{
								if((yy<<4) == y || yy == 8)	// Mirar solo en el recuadro izquierdo
								{
									if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1)
										phantomas.x-=512;
								}
								else	// Mirar, adems, en el inferior izquierdo.
								{
									if((mapa[pantalla].tiles[yy][xx-1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx-1].status & 1) != 1)
										phantomas.x-=512;
								}
							}
							else
								phantomas.x-=512;
						}
						else
							phantomas.mira_izda = CIERTO;
					
					}
					else if(key[KEY_RIGHT] || key[KEY_P])		// Derecha
					{
						if (!phantomas.mira_izda)
						{
							phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512
							phantomas.frame+=24;
							
							if(phantomas.frame==96)
								phantomas.frame=0;
							
							phantomas.mira_izda=FALSO;
							
							if((xx<<4) == x && xx != 14)
							{
								if((yy<<4) == y || yy == 8)	// Mirar solo en el recuadro derecho
								{
									if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1)
										phantomas.x+=512;
								}
								else	// Mirar, adems, en el inferior izquierdo.
								{
									if((mapa[pantalla].tiles[yy][xx+1].status & 1) != 1 && (mapa[pantalla].tiles[yy+1][xx+1].status & 1) != 1)
										phantomas.x+=512;
								}
							}
							else
								phantomas.x+=512;
						}
						else
							phantomas.mira_izda = FALSO;
					}
					
					if (phantomas.x != i && (yp == 0 || yp == 3))
						gengotas = 1;
					
					// Comprobamos si salimos de la pantalla por la izquierda o por la derecha
					if(phantomas.x<0)
					{
						phantomas.x=0;
					}
					
					if(phantomas.x>57344)
					{
						phantomas.x=57344;
					}
					
					// Bueno, ya est to el pescao vendo. Pero para que todo lo de arriba funcione
					// hay que leer las teclas de salto.
					
					// Como soy un moas pongo cursor arriba, Q para los 8biteros y Z para los phantomeros 1.
					// Igualmente con cursor abajo, A y SHIFT.
					
					if(key[KEY_UP] || key[KEY_Q] || key[KEY_Z])				// Salto alto
					{
						if (yp == 0 || yp == 3)
							gengotas = 1;
						
						if(CFG_soundon)
						{
							chnl=FSOUND_PlaySound(FSOUND_FREE,s_salto);
							FSOUND_SetPan(chnl,8+(phantomas.x>>8));
						}
						phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512
						phantomas.saltando=CIERTO;
						phantomas.salto_largo=FALSO;
						phantomas.contador_salto=0;
						mitad=16;
					}
					else if(key[KEY_DOWN] || key[KEY_A] || key[KEY_LSHIFT])		// Salto largo
					{
						if (yp == 0 || yp == 3)
							gengotas = 1;
							
						if(CFG_soundon)
						{
							chnl=FSOUND_PlaySound(FSOUND_FREE,s_salto);
							FSOUND_SetPan(chnl,8+(phantomas.x>>8));
						}
						phantomas.x=(phantomas.x>>9)<<9;		// Ajusta a mltiplo de 512						phantomas.saltando=CIERTO;
						phantomas.saltando=CIERTO;
						phantomas.salto_largo=CIERTO;
						phantomas.contador_salto=0;
						mitad=16;
					}
					
					if (gengotas)
					{
						gengotas = 0;
						
						// Buscamos 2 huecos libres en los salpicones.
						
						for (j = 0; j < 2; j ++)
							for (k = MAX_GOTAS; k < MAX_MVL; k ++)
								if ( mvl [k].ctbls == 0 )
								{
									mvl [k].ctbls = 1;
									mvl [k].frame = 0;
									mvl [k].x = phantomas.x + 2048;
									mvl [k].y = phantomas.y + 4096;
									
									mvl [k].my =- (256 + (rand () & 255));
									mvl [k].mx = (rand () & 511) - 256;
									
									k = MAX_MVL;
								}						
					}
				}
			}
			
			// Mover los enemigos y plataformas:
			
			for(i=0;i<NENEM-1;i++)
			{
				if(enemigos[i].id!=-1)
				{
					if (flip_flop)
					{
						enemigos[i].frame+=24;
						if(enemigos[i].frame==96) enemigos[i].frame=0;
					}
					
					enemigos[i].x=enemigos[i].x+enemigos[i].mx;
					enemigos[i].y=enemigos[i].y+enemigos[i].my;
					
					if(enemigos[i].x == enemigos[i].ini_x ||  enemigos[i].x == enemigos[i].fin_x)
						enemigos[i].mx=-enemigos[i].mx;
					
					if(enemigos[i].y == enemigos[i].ini_y ||  enemigos[i].y == enemigos[i].fin_y)
						enemigos[i].my=-enemigos[i].my;
				}
			}
			
			for(i=0;i<NENEM-1;i++)
			{
				if(plat[i].id!=-1)
				{
					if (flip_flop)
					{
						plat[i].frame+=24;
						if(plat[i].frame==96) plat[i].frame=0;
					}
					
					plat[i].x=plat[i].x+plat[i].mx;
					plat[i].y=plat[i].y+plat[i].my;
					
					if(plat[i].x == plat[i].ini_x ||  plat[i].x == plat[i].fin_x)
						plat[i].mx=-plat[i].mx;
					
					if(plat[i].y == plat[i].ini_y ||  plat[i].y == plat[i].fin_y)
						plat[i].my=-plat[i].my;
				}
			}
			
			// Vuelca:
			render(phantomas,enemigos,plat,mapa,palancas,energias,pantalla,\
			tiles,sprites,fondos,p_juego,cabecera);
			
			// Colisiones:
			
			x=(phantomas.x>>8); y=(phantomas.y>>8);
			xx=x>>4; yy=y>>4;
			
			// Exclusivo phantomasa: Empujar plataformas
			for(i=0;i<NENEM-1;i++)
			{
				if(plat[i].id==23)
				{
					int cct=0;
					while(x>=plat[i].x-15 && x<=plat[i].x+15 && y>=plat[i].y-15 && y<=plat[i].y+15 && cct<4)
					{
						cct++;
						if(x>plat[i].x+7)
						{
							if(plat[i].x>0)
								plat[i].x--;
							else
							{
								phantomas.x+=256;
								x=(phantomas.x>>8);
							}
						}
						else
						{
							if(plat[i].x<224)
								plat[i].x++;
							else
							{
								phantomas.x-=256;
								x=(phantomas.x>>8);
							}
						}
					}
				}
			}
			
			if(xp!=xpa || yp!=ypa)
			{
				pantalla=5*yp+xp;
				
				for(i=0;i<NENEM-1;i++)
				{
					enemigos[i].x=mapa[pantalla].enemigos[i].ini_x*16;
					enemigos[i].y=mapa[pantalla].enemigos[i].ini_y*16;
					
					enemigos[i].mx=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_x - mapa[pantalla].enemigos[i].ini_x);
					enemigos[i].my=mapa[pantalla].enemigos[i].vel * signo(mapa[pantalla].enemigos[i].fin_y - mapa[pantalla].enemigos[i].ini_y);
					
					enemigos[i].id=mapa[pantalla].enemigos[i].id;
					enemigos[i].frame=0;
					enemigos[i].ini_x=mapa[pantalla].enemigos[i].ini_x*16;
					enemigos[i].ini_y=mapa[pantalla].enemigos[i].ini_y*16;
					enemigos[i].fin_x=mapa[pantalla].enemigos[i].fin_x*16;
					enemigos[i].fin_y=mapa[pantalla].enemigos[i].fin_y*16;
				}
			}
			
			// 1. Con los enemigos:
			
			for(i=0;i<NENEM-1;i++)
			{
				if(enemigos[i].id!=-1)
				{
					if(x>=enemigos[i].x-15 && x<=enemigos[i].x+15 && y>=enemigos[i].y-15 && y<=enemigos[i].y+15)
					{
						if(CFG_soundon)
						{
							if(CFG_soundon)
							{
								if(chnl_en!=-1)
									FSOUND_StopSound(chnl_en);
								chnl=FSOUND_PlaySound(FSOUND_FREE,s_enemigo);
								FSOUND_SetPan(chnl,8+(phantomas.x>>8));
								chnl_en=chnl;
							}
						}
						phantomas.energia--;
						
					}
				}
			}
			
			// 1.5. Con el moco
			
			if (fila == 4 && y < moco_y) {
				if(CFG_soundon)	{
					if(chnl_en!=-1)
						FSOUND_StopSound(chnl_en);
					chnl=FSOUND_PlaySound(FSOUND_FREE,s_enemigo);
					FSOUND_SetPan(chnl,8+(phantomas.x>>8));
					chnl_en=chnl;
				}
				phantomas.energia--;
			}
			
			// 2. Con las palancas
			
			for(i=0;i<25;i++)
			{
				if(palancas[i].n == pantalla)
				{
					if(x>=(palancas[i].x<<4)-15 && x<=(palancas[i].x<<4)+15 && y>=(palancas[i].y<<4)-15 && y<=(palancas[i].y<<4)+15 && palancas[i].on)
					{
						if(CFG_soundon)
						{
							chnl=FSOUND_PlaySound(FSOUND_FREE,s_palanca);
							FSOUND_SetPan(chnl,8+(phantomas.x>>8));
						}
						phantomas.n_palancas++;
						palancas[i].on=FALSO;
						terminado=CIERTO;
						/*xp++;
						if (xp==5)
							{
						xp=0;
						yp++;
						 }*/
						GAME_sublevel++;
					}
				}
			}
			
			// 3. Con las energas
			
			for(i=0;i<25;i++)
			{
				if(energias[i].n == pantalla)
				{
					if(x>=(energias[i].x<<4)-15 && x<=(energias[i].x<<4)+15 && y==(energias[i].y<<4) && energias[i].on)
					{
						if(CFG_soundon)
						{
							chnl=FSOUND_PlaySound(FSOUND_FREE,s_energia);
							FSOUND_SetPan(chnl,8+(phantomas.x>>8));
						}
						energias[i].on=FALSO;
						if(phantomas.energia<=230)
							phantomas.energia+=25;
						else
							phantomas.energia=255;
						
					}
				}
			}
			
			// 4. Con los tiles malos
			
			if((mapa[pantalla].tiles[yy][xx].status & 2 ) == 2)
			{
				if(CFG_soundon)
				{
					if(chnl_en!=-1)
						FSOUND_StopSound(chnl_en);
					chnl=FSOUND_PlaySound(FSOUND_FREE,s_enemigo);
					FSOUND_SetPan(chnl,8+(phantomas.x>>8));
					chnl_en=chnl;
				}
				phantomas.energia--;
				
			}
			// Comprobaciones:
			
			if(phantomas.energia<=0 || close_button_pressed)
			{
				terminado=CIERTO;
				finalizar=CIERTO;
				exito=GAMEOVER;
			}	
			
			// El control derecho salva una instantanea.
			// Ojo que pisa a la anterior si la haba.
			// Renmbrala rpido, illo!
			
			if(key[KEY_RCONTROL])
				save_bitmap("CAP.PCX",screen,pal);
			
			if(phantomas.n_palancas==25 && xp==cabecera.pfi_x && yp==cabecera.pfi_y \
			&& y==((cabecera.fin_y+1)<<4) && x==(cabecera.fin_x<<4))
			{
				// EOG!
				exito=CORRECTO;
				terminado=CIERTO;
				finalizar=CIERTO;
			}
			
			// Blitter:
			blitter(p_juego,pcx,aux,vacio,lleno,phantomas.energia,fasegrande,fasechica,intentos);
			
			// Temporizacin:
			while(contador_60Hz<2);
			contador_60Hz=0;
			
			// Retry:
			if(key[KEY_R])
			{
				if(yes_no(p_juego,pcx,aux,vacio,lleno,phantomas.energia,fasegrande,fasechica,intentos))
				{
					intentos--;
					terminado=CIERTO;
				}
			}
			
		}
		if(intentos<0)
		{
			exito=GAMEOVER;
			finalizar=CIERTO;
		}
		
		if (GAME_sublevel > 25) finalizar = CIERTO;
	}

	loga ("Fin del bucle del juego");
	
	if(CFG_soundon)
	{
		loga ("Liberando memoria de samples y msica");
		FMUSIC_FreeSong(musica);
		FSOUND_Sample_Free(s_salto);
		FSOUND_Sample_Free(s_energia);
		FSOUND_Sample_Free(s_palanca);
		FSOUND_Sample_Free(s_caer);
		FSOUND_Sample_Free(s_enemigo);
		FSOUND_Sample_Free(s_suelo);
	}
	
	loga ("Destruyendo bitmaps");
	
	for(i=0;i<240;i++)
	{
		destroy_bitmap(tiles[i]);
		destroy_bitmap(sprites[i]);
	}
	
	for(i=0;i<5;i++)
		destroy_bitmap(fondos[i]);
	
	destroy_bitmap(p_juego);
	destroy_bitmap(aux);
	destroy_bitmap(pcx);
	destroy_bitmap(vacio);
	destroy_bitmap(lleno);
	destroy_bitmap(scr);
	
	destroy_bitmap (sp_nubes1);
	destroy_bitmap (sp_nubes2);
	destroy_bitmap (sp_overlay_fila4);
	destroy_bitmap (sp_anti_halo);
	destroy_bitmap (sp_fancy_overlay);
	
	destroy_bitmap (buffer_auxiliar);
	destroy_bitmap (buffer_auxiliar_2);
	destroy_bitmap (buffer_auxiliar_3);
	
	for (i = 0; i < 6; i ++)
		destroy_bitmap (sp_gotas [i]);
		
	for (i = 0; i < 4; i ++)
		destroy_bitmap (sp_moco [i]);
		
	//
	
	loga ("FINE");
	
	return(exito);
}



