#include <stdio.h>
#include <allegro.h>
#include <fmod.h>
#include "defs.h"
#include "gfx.h"
#include "key.h"
#include "menu_intro.h"
#include "temporizadores.h"
#include "motor.h"
#include "clave.h"
#include "closebuttonhandler.h"

void main(void)
{
	BITMAP *buffer;
	BITMAP *loader;
	PALETTE dummy;
	FILE *pf;
	LOGICO terminado;
	LOGICO _esc_;
	int result;
	char password[]="....";
	char c,scan;
	int kay;
	int i;
	FMUSIC_MODULE *musica;
	
	// Read CFG file
	
	if( (pf = fopen("Phantomasa.Cfg","rb")) == NULL )
	{
		pf=fopen("Phantomasa.Cfg","wb");
		CFG_scanlines=CIERTO;
		CFG_soundon=CIERTO;
		CFG_bitdepth=16;
		CFG_soundvol=127;
		CFG_sfxvol=127;
		CFG_samplerate=44100;
		fwrite(&CFG_scanlines,sizeof(int),1,pf);
		fwrite(&CFG_soundon,sizeof(int),1,pf);
		fwrite(&CFG_bitdepth,sizeof(int),1,pf);
		fwrite(&CFG_soundvol,sizeof(int),1,pf);
		fwrite(&CFG_sfxvol,sizeof(int),1,pf);
		fwrite(&CFG_samplerate,sizeof(int),1,pf);
		fclose(pf);
	}
	else
	{
		fread(&CFG_scanlines,sizeof(int),1,pf);
		fread(&CFG_soundon,sizeof(int),1,pf);
		fread(&CFG_bitdepth,sizeof(int),1,pf);
		fread(&CFG_soundvol,sizeof(int),1,pf);
		fread(&CFG_sfxvol,sizeof(int),1,pf);
		fread(&CFG_samplerate,sizeof(int),1,pf);
		fclose(pf);
	}
	
	
	allegro_init();
	
	LOCK_FUNCTION(close_button_handler);
	set_close_button_callback(close_button_handler);
	close_button_pressed = FALSE;
	
	install_timer();
	instala_temporizador_60Hz();
	
	// Iniciar sonido:
	
	result=FSOUND_Init(CFG_samplerate,32,FSOUND_INIT_GLOBALFOCUS);
	
	if(CFG_soundon)
	{
		s_back =  FSOUND_Sample_Load(FSOUND_FREE,"resources/back.wav",  FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_go   =  FSOUND_Sample_Load(FSOUND_FREE,"resources/go.wav",	FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
		s_ting =  FSOUND_Sample_Load(FSOUND_FREE,"resources/ting.wav",  FSOUND_LOOP_OFF | FSOUND_2D, 0, 0);
	}
	
	set_color_depth(CFG_bitdepth);
	set_gfx_mode(GFX_AUTODETECT_WINDOWED,512,384,0,0);
	set_color_conversion(COLORCONV_TOTAL);
	
	// Init:
	
	loader=create_bitmap(1,1); // Estoy harto del puto warning
	
	GFX_init();
	if(!CFG_scanlines)
		GFX_noscanlines();
	else
		GFX_scanlines();
	
	buffer=create_bitmap(512,384);
	GFX_load_font("RESOURCES/ATARI.8x8");
	clear(buffer);
	
	if(install_keyboard()!=0)
		exit(-1);
	
	// Initial message:
	
	intro(buffer,loader,dummy);
	
	MENU_opt=1;
	
	// Menu:
	
	musica=FMUSIC_LoadSong("Resources/Title.XM");
	FMUSIC_SetMasterVolume(musica,CFG_soundvol<<1);
	FMUSIC_PlaySong(musica);
	
	result=menu(CIERTO,buffer,loader,dummy);		// Cierto: Intro animation, Falso: No
	
	while (result!=4 && !close_button_pressed)
	{
		if(result==1)
		{
			GAME_level=1;
			GAME_sublevel=1;
			FMUSIC_StopSong(musica);
			result=juego("phasa1.ph3",1);
			while (key[KEY_ESC]);
		}
		else if(result==2)
		{
			// Password
			i=0;
			terminado=FALSO;
			_esc_=FALSO;
			clear(buffer);
			GFX_centra(buffer,88,-1,"ENTER PASSWORD");
			GFX_centra(buffer,100,-1,password);
			GFX_blitall(buffer);
			while(!terminado)
			{
				kay=readkey();
				c=kay & 0xff;
				scan=kay >> 8;
				if (c>'Z')
					c-=32;
				if ( ( (c>='A' && c<='Z') || (c>='0' && c<='9') ) && i<4)
				{
					password[i]=c;
					i++;
					while(key[scan]);
					clear_keybuf();
				}
				if (scan == KEY_BACKSPACE && i>0)
				{
					i--;
					password[i]='.';
					while(key[KEY_BACKSPACE]);
					clear_keybuf();
				}
				if (scan == KEY_ENTER)
				{
					if (i==4)
						terminado=CIERTO;
					while(key[KEY_ENTER]);
					clear_keybuf();
				}
				if (scan == KEY_ESC)
				{
					terminado=CIERTO;
					_esc_=CIERTO;
				}
				clear(buffer);
				GFX_centra(buffer,88,-1,"ENTER PASSWORD");
				GFX_centra(buffer,100,-1,password);
				GFX_blitall(buffer);
			}
			
			// Check password:
			
			if(!_esc_)
			{
				
				result=CLAVE_decodifica_clave(password);
				
				if(result==0)
				{
					clear(buffer);
					GFX_centra(buffer,88,-1,"WRONG PASSWORD");
					GFX_blitall(buffer);
					KEY_wait_action_key();
				}
				else
				{
					GAME_sublevel=result % 25;
					GAME_level=result / 25;
					FMUSIC_StopSong(musica);
					result=juego("phasa1.ph3",1);
					while (key[KEY_ESC]);
				}
				
				for(i=0;i<4;i++)
					password[i]='.';
				password[4]=0;
			}
		}
		else if(result==3)
		{
			FMUSIC_StopSong(musica);
			// User Level
		}
		
		if (!close_button_pressed) {
			FMUSIC_PlaySong(musica);
	
			result=menu(FALSO,buffer,loader,dummy);
		}
	}
	
	// Exit secuence (deinitializations)
	
	remove_keyboard();
	
	if(CFG_soundon)
	{
		FSOUND_Sample_Free(s_go);
		FSOUND_Sample_Free(s_back);
		FSOUND_Sample_Free(s_ting);
	}
	
	FSOUND_Close();
	allegro_exit();
}
END_OF_MAIN();
